
#ifndef _BASE_BLOCK_HXX
#define _BASE_BLOCK_HXX 1

#include <string.h>

  class Block {
   public:
    class Segment {
      const char *_pchBase;
      const char *_pchCur;
      size_t _cData;
      size_t _cBlock;
      const char *pchLim() const { return _pchBase+_cData; }

     public:


      /* current block information */
      const char *pchCur() const { return _pchCur; }
      size_t lenCur() const { return ((unsigned)(pchLim()-pchCur()) > _cBlock) ? _cBlock :  pchLim()-pchCur(); }

      size_t cDone() const { return (_pchCur-_pchBase); }
      size_t cRem() const { return (pchLim()-pchCur()); }

      bool isMore() const { return pchCur() < pchLim(); }
      bool isLast() const { return ((unsigned)(pchLim()-pchCur()) <= _cBlock); }

      void seek (size_t c) { _pchCur += c; }
      void seekBlock() { _pchCur += _cBlock; }

      Segment( const char *pch, size_t cData, size_t cBlock ):_pchBase(pch), _pchCur(pch), _cData(cData), _cBlock(cBlock) {}
      Segment( ):_pchBase(0), _pchCur(0), _cData(0), _cBlock(0) {}
      ~Segment( ) {}
    };

  private:

    Segment _sg;		/* internal	*/

    Segment *_psgFirst;
    Segment *_psgCur;
    Segment *_psgLim;

    bool isLastSeg() const { return (_psgCur+1) >= _psgLim; }
    Segment *psgCur() { return _psgCur; }
    const Segment *psgCurConst() const { return _psgCur; }
    void seekSeg() { if (!_psgCur->isMore() && !isLastSeg()) _psgCur++; }

  public:

    /* current block information */
    const char *pchCur() const { return psgCurConst()->pchCur(); }
    size_t lenCur() const { return psgCurConst()->lenCur(); }

    size_t cDone() const ;

    bool isMore() const { return !isLastSeg() || psgCurConst()->isMore(); }
    bool isLast() const { return isLastSeg() && psgCurConst()->isLast(); }

    void seek (size_t c) { psgCur()->seek(c); seekSeg(); }
    void seekBlock() { psgCur()->seekBlock(); seekSeg(); }

    Block( const char *pch, size_t cData, size_t cBlock );
    Block( Segment *psg, int cSeg );
    ~Block( );
  };

#endif
