/*
 * This file is automatically created
 * DO NOT EDIT
 */
#include "gpibc/gumi.hxx"
#include "umic/umi.hxx"
#ifndef _GUMI_MSGS_HXX_
#define _GUMI_MSGS_HXX_
typedef INdepUmi100::Time UmiTime;
namespace INdepGpib100 {

  // 0 0


  /*
   * class GpibTermOut - send termination descriptor
   */

  class GpibTermOut {
    u_int _chEos;	/* EOS byte for END	*/
    u_int _fEnd;	/* set END on last byte	*/
    u_int _fEoiEos;	/* set END on EOS	*/
    u_int _fEos7;	/* 7 bit EOS recognition	*/
    u_int _fHighSpeed;	/* use high-speed timing	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibTermOut&);
     friend xostream& xmarshal(xostream &xo, const GpibTermOut&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibTermOut&);
    #endif
    char chEos() const { return (char) _chEos; }
    GpibTermOut& chEos(char __chEos) { _chEos=__chEos ; return *this; }
    bool fEnd() const { return _fEnd!= 0 ; }
    GpibTermOut& fEnd(bool __fEnd) { _fEnd=__fEnd ; return *this; }
    bool fEoiEos() const { return _fEoiEos!= 0 ; }
    GpibTermOut& fEoiEos(bool __fEoiEos) { _fEoiEos=__fEoiEos ; return *this; }
    bool fEos7() const { return _fEos7!= 0 ; }
    GpibTermOut& fEos7(bool __fEos7) { _fEos7=__fEos7 ; return *this; }
    bool fHighSpeed() const { return _fHighSpeed!= 0 ; }
    GpibTermOut& fHighSpeed(bool __fHighSpeed) { _fHighSpeed=__fHighSpeed ; return *this; }

    GpibTermOut():_chEos(0),_fEnd(false),_fEoiEos(false),_fEos7(false),_fHighSpeed(false) { }
    GpibTermOut(char chEos,bool fEnd,bool fEoiEos,bool fEos7,bool fHighSpeed):_chEos(chEos),_fEnd(fEnd),_fEoiEos(fEoiEos),_fEos7(fEos7),_fHighSpeed(fHighSpeed) { }
    ~GpibTermOut() {}
  };
  // 0 0


  /*
   * class GpibTermIn - receive termination descriptor
   */

  class GpibTermIn {
    u_int _cEos;	/* EOS byte count	*/
    u_int _fDelEnd;	/* END message terminates transfer	*/
    u_int _fEos7;	/* 7 bit EOS recognition	*/
    u_int _mpchEos[3];	/* EOS characters	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibTermIn&);
     friend xostream& xmarshal(xostream &xo, const GpibTermIn&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibTermIn&);
    #endif
    u_int cEos() const { return _cEos; }
    GpibTermIn& cEos(u_int __cEos) { _cEos=__cEos ; return *this; }
    bool fDelEnd() const { return _fDelEnd!= 0 ; }
    GpibTermIn& fDelEnd(bool __fDelEnd) { _fDelEnd=__fDelEnd ; return *this; }
    bool fEos7() const { return _fEos7!= 0 ; }
    GpibTermIn& fEos7(bool __fEos7) { _fEos7=__fEos7 ; return *this; }
    char chEos(int i) const { return (char) _mpchEos[i]; }
    void chEos( int i, char __chEos) { _mpchEos[i]=__chEos ; }

    GpibTermIn():_cEos(0),_fDelEnd(true),_fEos7(false) { }
    GpibTermIn(u_int cEos,bool fDelEnd,bool fEos7):_cEos(cEos),_fDelEnd(fDelEnd),_fEos7(fEos7) { }
    ~GpibTermIn() {}
  };
  // 0 0


  /*
   * class GpibIfConf - Interface configuration
   */

  class GpibIfConf {
    u_int _fSc;	/* system controller	*/
    u_int _iPa;	/* primary interface address	*/
    u_int _fSa;	/* secondary interface address flag	*/
    u_int _iSa;	/* secondary interface address	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibIfConf&);
     friend xostream& xmarshal(xostream &xo, const GpibIfConf&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibIfConf&);
    #endif
    bool fSc() const { return _fSc!= 0 ; }
    GpibIfConf& fSc(bool __fSc) { _fSc=__fSc ; return *this; }
    u_int iPa() const { return _iPa; }
    GpibIfConf& iPa(u_int __iPa) { _iPa=__iPa ; return *this; }
    bool fSa() const { return _fSa!= 0 ; }
    GpibIfConf& fSa(bool __fSa) { _fSa=__fSa ; return *this; }
    u_int iSa() const { return _iSa; }
    GpibIfConf& iSa(u_int __iSa) { _iSa=__iSa ; return *this; }

    GpibIfConf():_fSc(false),_iPa(0),_fSa(false),_iSa(0) { }
    GpibIfConf(bool fSc,u_int iPa,bool fSa,u_int iSa):_fSc(fSc),_iPa(iPa),_fSa(fSa),_iSa(iSa) { }
    ~GpibIfConf() {}
  };
  // 0 0


  /*
   * class GpibInfo - Interface information
   */

  class GpibInfo {
    u_int _eArch;	/* interface architecture id	*/
    u_int _cIntr;	/* hardware interrupt counter	*/
    u_int _fLinec;	/* line sense capability	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibInfo&);
     friend xostream& xmarshal(xostream &xo, const GpibInfo&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibInfo&);
    #endif
    u_int eArch() const { return _eArch; }
    GpibInfo& eArch(u_int __eArch) { _eArch=__eArch ; return *this; }
    u_int cIntr() const { return _cIntr; }
    GpibInfo& cIntr(u_int __cIntr) { _cIntr=__cIntr ; return *this; }
    u_int fLinec() const { return _fLinec; }
    GpibInfo& fLinec(u_int __fLinec) { _fLinec=__fLinec ; return *this; }

    GpibInfo():_eArch(0),_cIntr(0),_fLinec(0) { }
    GpibInfo(u_int eArch,u_int cIntr,u_int fLinec):_eArch(eArch),_cIntr(cIntr),_fLinec(fLinec) { }
    ~GpibInfo() {}
  };
  // 4 1


  /*
   * class GpibNop - no operation
   */

  class GpibNop:public Umi::UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibNop&);
     friend xostream& xmarshal(xostream &xo, const GpibNop&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibNop&);
    #endif

    GpibNop(int e=0x4, size_t s=0);
    ~GpibNop() {}
  };
  // 5 0


  /*
   * class GpibPeek - register read
   */

  class GpibPeek:public Umi::UmiControl  {
    u_int _iPort;	/* register number	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibPeek&);
     friend xostream& xmarshal(xostream &xo, const GpibPeek&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibPeek&);
    #endif
    u_int iPort() const { return _iPort; }
    GpibPeek& iPort(u_int __iPort) { _iPort=__iPort ; return *this; }

    GpibPeek(int e=0x5, size_t s=0);
    ~GpibPeek() {}
  };
  // 6 0


  /*
   * class GpibPoke - register write
   */

  class GpibPoke:public GpibPeek  {
    u_int _iVal;	/* register value	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibPoke&);
     friend xostream& xmarshal(xostream &xo, const GpibPoke&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibPoke&);
    #endif
    u_int iVal() const { return _iVal; }
    GpibPoke& iVal(u_int __iVal) { _iVal=__iVal ; return *this; }

    GpibPoke(int e=0x6, size_t s=0);
    ~GpibPoke() {}
  };
  // 7 0


  /*
   * class GpibSta - status report
   */

  class GpibSta:public Umi::UmiControl  {
    u_int _iStb;	/* status byte	*/
    u_int _fMss;	/* summary status	*/
    u_int _fNew;	/* new summary status	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibSta&);
     friend xostream& xmarshal(xostream &xo, const GpibSta&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibSta&);
    #endif
    u_int iStb() const { return _iStb; }
    GpibSta& iStb(u_int __iStb) { _iStb=__iStb ; return *this; }
    bool fMss() const { return _fMss!= 0 ; }
    GpibSta& fMss(bool __fMss) { _fMss=__fMss ; return *this; }
    bool fNew() const { return _fNew!= 0 ; }
    GpibSta& fNew(bool __fNew) { _fNew=__fNew ; return *this; }

    GpibSta(int e=0x7, size_t s=0);
    ~GpibSta() {}
  };
  // 8 1


  /*
   * class GpibTrf - common transfer parameters
   */

  class GpibTrf:public Umi::UmiControl  {
    UmiTime _tiTmo;
    u_int _iTrans;	/* transaction id	*/
    u_int _fLast;	/* last of transaction	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibTrf&);
     friend xostream& xmarshal(xostream &xo, const GpibTrf&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibTrf&);
    #endif
    const UmiTime& tiTmo() const { return _tiTmo; }
    void tiTmo( const UmiTime& __tiTmo) {_tiTmo=__tiTmo ; }
    u_int iTrans() const { return _iTrans; }
    GpibTrf& iTrans(u_int __iTrans) { _iTrans=__iTrans ; return *this; }
    bool fLast() const { return _fLast!= 0 ; }
    GpibTrf& fLast(bool __fLast) { _fLast=__fLast ; return *this; }

    GpibTrf(int e=0x8, size_t s=0);
    ~GpibTrf() {}
  };
  // 9 0


  /*
   * class GpibInit - Interface initialization
   */

  class GpibInit:public Umi::UmiControl  {
    GpibIfConf _ifConfig;
   public:
     friend xistream& xunmarsh(xistream &xi, GpibInit&);
     friend xostream& xmarshal(xostream &xo, const GpibInit&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibInit&);
    #endif
    const GpibIfConf& ifConfig() const { return _ifConfig; }
    void ifConfig( const GpibIfConf& __ifConfig) {_ifConfig=__ifConfig ; }

    GpibInit(int e=0x9, size_t s=0);
    ~GpibInit() {}
  };
  // a 0


  /*
   * class GpibFini - Interface shutdown
   */

  class GpibFini:public Umi::UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibFini&);
     friend xostream& xmarshal(xostream &xo, const GpibFini&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibFini&);
    #endif

    GpibFini(int e=0xa, size_t s=0);
    ~GpibFini() {}
  };
  // b 0


  /*
   * class GpibCmd - send commands request
   */

  class GpibCmd:public GpibTrf  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibCmd&);
     friend xostream& xmarshal(xostream &xo, const GpibCmd&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibCmd&);
    #endif

    GpibCmd(int e=0xb, size_t s=0);
    ~GpibCmd() {}
  };
  // c 0


  /*
   * class GpibCwr - send data request
   */

  class GpibCwr:public GpibTrf  {
    GpibTermOut _termOut;
   public:
     friend xistream& xunmarsh(xistream &xi, GpibCwr&);
     friend xostream& xmarshal(xostream &xo, const GpibCwr&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibCwr&);
    #endif
    const GpibTermOut& termOut() const { return _termOut; }
    void termOut( const GpibTermOut& __termOut) {_termOut=__termOut ; }

    GpibCwr(int e=0xc, size_t s=0);
    ~GpibCwr() {}
  };
  // d 0


  /*
   * class GpibCrd - receive data request
   */

  class GpibCrd:public Umi::UmiControl  {
    GpibTermIn _termIn;
    UmiTime _tiTmo;
    u_int _cMax;	/* maximum transfer count read	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibCrd&);
     friend xostream& xmarshal(xostream &xo, const GpibCrd&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibCrd&);
    #endif
    const GpibTermIn& termIn() const { return _termIn; }
    void termIn( const GpibTermIn& __termIn) {_termIn=__termIn ; }
    const UmiTime& tiTmo() const { return _tiTmo; }
    void tiTmo( const UmiTime& __tiTmo) {_tiTmo=__tiTmo ; }
    u_int cMax() const { return _cMax; }
    GpibCrd& cMax(u_int __cMax) { _cMax=__cMax ; return *this; }

    GpibCrd(int e=0xd, size_t s=0);
    ~GpibCrd() {}
  };
  // e 0


  /*
   * class GpibResp - status response
   */

  class GpibResp:public Umi::UmiControl  {
    u_int _eErr;	/* result (error) code	*/
    u_int _iErr;	/* result (error) code, detailed	*/
    u_int _fStat;	/* status flags (StatE)	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibResp&);
     friend xostream& xmarshal(xostream &xo, const GpibResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibResp&);
    #endif
    u_int eErr() const { return _eErr; }
    GpibResp& eErr(u_int __eErr) { _eErr=__eErr ; return *this; }
    u_int iErr() const { return _iErr; }
    GpibResp& iErr(u_int __iErr) { _iErr=__iErr ; return *this; }
    u_int fStat() const { return _fStat; }
    GpibResp& fStat(u_int __fStat) { _fStat=__fStat ; return *this; }

    GpibResp(int e=0xe, size_t s=0);
    ~GpibResp() {}
  };
  // f 0


  /*
   * class GpibRdResp - read response
   */

  class GpibRdResp:public GpibResp  {
    u_int _fDel;	/* message terminated	*/
    u_int _fDelEnd;	/* message terminated by END	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibRdResp&);
     friend xostream& xmarshal(xostream &xo, const GpibRdResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibRdResp&);
    #endif
    bool fDel() const { return _fDel!= 0 ; }
    GpibRdResp& fDel(bool __fDel) { _fDel=__fDel ; return *this; }
    bool fDelEnd() const { return _fDelEnd!= 0 ; }
    GpibRdResp& fDelEnd(bool __fDelEnd) { _fDelEnd=__fDelEnd ; return *this; }

    GpibRdResp(int e=0xf, size_t s=0);
    ~GpibRdResp() {}
  };
  // 10 1


  /*
   * class GpibWrResp - write response
   */

  class GpibWrResp:public GpibResp  {
    u_int _cTrans;	/* bytes transmitted	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibWrResp&);
     friend xostream& xmarshal(xostream &xo, const GpibWrResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibWrResp&);
    #endif
    u_int cTrans() const { return _cTrans; }
    GpibWrResp& cTrans(u_int __cTrans) { _cTrans=__cTrans ; return *this; }

    GpibWrResp(int e=0x10, size_t s=0);
    ~GpibWrResp() {}
  };
  // 11 0


  /*
   * class GpibInfoResp - info response
   */

  class GpibInfoResp:public GpibResp  {
    GpibInfo _info;
   public:
     friend xistream& xunmarsh(xistream &xi, GpibInfoResp&);
     friend xostream& xmarshal(xostream &xo, const GpibInfoResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibInfoResp&);
    #endif
    const GpibInfo& info() const { return _info; }
    void info( const GpibInfo& __info) {_info=__info ; }

    GpibInfoResp(int e=0x11, size_t s=0);
    ~GpibInfoResp() {}
  };
  // 12 0


  /*
   * class GpibIfc - send IFC
   */

  class GpibIfc:public Umi::UmiControl  {
    UmiTime _ti;
   public:
     friend xistream& xunmarsh(xistream &xi, GpibIfc&);
     friend xostream& xmarshal(xostream &xo, const GpibIfc&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibIfc&);
    #endif
    const UmiTime& ti() const { return _ti; }
    void ti( const UmiTime& __ti) {_ti=__ti ; }

    GpibIfc(int e=0x12, size_t s=0);
    ~GpibIfc() {}
  };
  // 13 0


  /*
   * class GpibRen - REN control
   */

  class GpibRen:public Umi::UmiControl  {
    u_int _fSet;	/* set/clr flag	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibRen&);
     friend xostream& xmarshal(xostream &xo, const GpibRen&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibRen&);
    #endif
    bool fSet() const { return _fSet!= 0 ; }
    GpibRen& fSet(bool __fSet) { _fSet=__fSet ; return *this; }

    GpibRen(int e=0x13, size_t s=0);
    ~GpibRen() {}
  };
  // 14 0


  /*
   * class GpibWait - wait for event
   */

  class GpibWait:public Umi::UmiControl  {
    UmiTime _ti;
    u_int _fWait;	/* status wait flags (StatE)	*/
    u_int _fClear;	/* clear event flags (StatE)	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibWait&);
     friend xostream& xmarshal(xostream &xo, const GpibWait&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibWait&);
    #endif
    const UmiTime& ti() const { return _ti; }
    void ti( const UmiTime& __ti) {_ti=__ti ; }
    u_int fWait() const { return _fWait; }
    GpibWait& fWait(u_int __fWait) { _fWait=__fWait ; return *this; }
    u_int fClear() const { return _fClear; }
    GpibWait& fClear(u_int __fClear) { _fClear=__fClear ; return *this; }

    GpibWait(int e=0x14, size_t s=0);
    ~GpibWait() {}
  };
  // 15 0


  /*
   * class GpibLnReq - lines status request
   */

  class GpibLnReq:public Umi::UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibLnReq&);
     friend xostream& xmarshal(xostream &xo, const GpibLnReq&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibLnReq&);
    #endif

    GpibLnReq(int e=0x15, size_t s=0);
    ~GpibLnReq() {}
  };
  // 16 0


  /*
   * class GpibLnResp - line status response
   */

  class GpibLnResp:public GpibResp  {
    u_int _fStat;	/* stat flag	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibLnResp&);
     friend xostream& xmarshal(xostream &xo, const GpibLnResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibLnResp&);
    #endif
    u_int fStat() const { return _fStat; }
    GpibLnResp& fStat(u_int __fStat) { _fStat=__fStat ; return *this; }

    GpibLnResp(int e=0x16, size_t s=0);
    ~GpibLnResp() {}
  };
  // 17 0


  /*
   * class GpibCsm - controller sm request
   */

  class GpibCsm:public Umi::UmiControl  {
    u_int _fCa;	/* make controller active/standby	*/
    u_int _fTcs;	/* take control synchronously	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibCsm&);
     friend xostream& xmarshal(xostream &xo, const GpibCsm&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibCsm&);
    #endif
    bool fCa() const { return _fCa!= 0 ; }
    GpibCsm& fCa(bool __fCa) { _fCa=__fCa ; return *this; }
    bool fTcs() const { return _fTcs!= 0 ; }
    GpibCsm& fTcs(bool __fTcs) { _fTcs=__fTcs ; return *this; }

    GpibCsm(int e=0x17, size_t s=0);
    ~GpibCsm() {}
  };
  // 18 0


  /*
   * class GpibIst - set individual status
   */

  class GpibIst:public Umi::UmiControl  {
    u_int _fIst;	/* set/clr ist	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibIst&);
     friend xostream& xmarshal(xostream &xo, const GpibIst&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibIst&);
    #endif
    bool fIst() const { return _fIst!= 0 ; }
    GpibIst& fIst(bool __fIst) { _fIst=__fIst ; return *this; }

    GpibIst(int e=0x18, size_t s=0);
    ~GpibIst() {}
  };
  // 19 0


  /*
   * class GpibRtl - return to local
   */

  class GpibRtl:public Umi::UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibRtl&);
     friend xostream& xmarshal(xostream &xo, const GpibRtl&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibRtl&);
    #endif

    GpibRtl(int e=0x19, size_t s=0);
    ~GpibRtl() {}
  };
  // 1a 0


  /*
   * class GpibPpc - parallel poll configure
   */

  class GpibPpc:public Umi::UmiControl  {
    u_int _fEnable;	/* enable	*/
    u_int _fSPPP;	/* sense/line flag	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibPpc&);
     friend xostream& xmarshal(xostream &xo, const GpibPpc&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibPpc&);
    #endif
    bool fEnable() const { return _fEnable!= 0 ; }
    GpibPpc& fEnable(bool __fEnable) { _fEnable=__fEnable ; return *this; }
    u_int fSPPP() const { return _fSPPP; }
    GpibPpc& fSPPP(u_int __fSPPP) { _fSPPP=__fSPPP ; return *this; }

    GpibPpc(int e=0x1a, size_t s=0);
    ~GpibPpc() {}
  };
  // 1b 0


  /*
   * class GpibRpp - request parallel poll
   */

  class GpibRpp:public Umi::UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibRpp&);
     friend xostream& xmarshal(xostream &xo, const GpibRpp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibRpp&);
    #endif

    GpibRpp(int e=0x1b, size_t s=0);
    ~GpibRpp() {}
  };
  // 1c 0


  /*
   * class GpibRppResp - request parallel poll response
   */

  class GpibRppResp:public GpibResp  {
    u_int _fPpr;	/* ppoll response 	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibRppResp&);
     friend xostream& xmarshal(xostream &xo, const GpibRppResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibRppResp&);
    #endif
    u_int fPpr() const { return _fPpr; }
    GpibRppResp& fPpr(u_int __fPpr) { _fPpr=__fPpr ; return *this; }

    GpibRppResp(int e=0x1c, size_t s=0);
    ~GpibRppResp() {}
  };
  // 1d 0


  /*
   * class GpibDeviceStatus - Device interface status
   */

  class GpibDeviceStatus:public Umi::UmiControl  {
    u_int _fStat;	/* status flag	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibDeviceStatus&);
     friend xostream& xmarshal(xostream &xo, const GpibDeviceStatus&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibDeviceStatus&);
    #endif
    u_int fStat() const { return _fStat; }
    GpibDeviceStatus& fStat(u_int __fStat) { _fStat=__fStat ; return *this; }

    GpibDeviceStatus(int e=0x1d, size_t s=0);
    ~GpibDeviceStatus() {}
  };
  // 1e 0


  /*
   * class GpibDeviceOutput - device output data
   */

  class GpibDeviceOutput:public Umi::UmiControl  {
    u_int _fEND;	/* message terminated by END	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibDeviceOutput&);
     friend xostream& xmarshal(xostream &xo, const GpibDeviceOutput&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibDeviceOutput&);
    #endif
    bool fEND() const { return _fEND!= 0 ; }
    GpibDeviceOutput& fEND(bool __fEND) { _fEND=__fEND ; return *this; }

    GpibDeviceOutput(int e=0x1e, size_t s=0);
    ~GpibDeviceOutput() {}
  };
  // 1f 0


  /*
   * class GpibDeviceInitAck - device INIT ack
   */

  class GpibDeviceInitAck:public Umi::UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, GpibDeviceInitAck&);
     friend xostream& xmarshal(xostream &xo, const GpibDeviceInitAck&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibDeviceInitAck&);
    #endif

    GpibDeviceInitAck(int e=0x1f, size_t s=0);
    ~GpibDeviceInitAck() {}
  };
  // 20 1


  /*
   * class GpibDeviceInput - device input data
   */

  class GpibDeviceInput:public GpibDeviceStatus  {
    u_int _fEND;	/* message terminated by END	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibDeviceInput&);
     friend xostream& xmarshal(xostream &xo, const GpibDeviceInput&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibDeviceInput&);
    #endif
    bool fEND() const { return _fEND!= 0 ; }
    GpibDeviceInput& fEND(bool __fEND) { _fEND=__fEND ; return *this; }

    GpibDeviceInput(int e=0x20, size_t s=0);
    ~GpibDeviceInput() {}
  };
  // 21 0


  /*
   * class GpibDeviceEvent - device event
   */

  class GpibDeviceEvent:public GpibDeviceStatus  {
    u_int _eEvent;	/* event enumerator	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibDeviceEvent&);
     friend xostream& xmarshal(xostream &xo, const GpibDeviceEvent&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibDeviceEvent&);
    #endif
    u_int eEvent() const { return _eEvent; }
    GpibDeviceEvent& eEvent(u_int __eEvent) { _eEvent=__eEvent ; return *this; }

    GpibDeviceEvent(int e=0x21, size_t s=0);
    ~GpibDeviceEvent() {}
  };
  // 22 0


  /*
   * class GpibDeviceStatusReport - device status report
   */

  class GpibDeviceStatusReport:public Umi::UmiControl  {
    u_int _fStb;	/* status byte	*/
    u_int _fSre;	/* srq enable	*/
    u_int _fForce;	/* force MAV	*/
   public:
     friend xistream& xunmarsh(xistream &xi, GpibDeviceStatusReport&);
     friend xostream& xmarshal(xostream &xo, const GpibDeviceStatusReport&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const GpibDeviceStatusReport&);
    #endif
    u_int fStb() const { return _fStb; }
    GpibDeviceStatusReport& fStb(u_int __fStb) { _fStb=__fStb ; return *this; }
    u_int fSre() const { return _fSre; }
    GpibDeviceStatusReport& fSre(u_int __fSre) { _fSre=__fSre ; return *this; }
    u_int fForce() const { return _fForce; }
    GpibDeviceStatusReport& fForce(u_int __fForce) { _fForce=__fForce ; return *this; }

    GpibDeviceStatusReport(int e=0x22, size_t s=0);
    ~GpibDeviceStatusReport() {}
  };

  inline bool isGpibNop(const Umi::UmiControl *puc) { return ((puc->eType() & 0x4)==0x4); }
  extern GpibNop* pGpibNop(Umi::UmiControl *);
  inline const GpibNop* pGpibNop(const Umi::UmiControl *puc) { return pGpibNop(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibPeek(const Umi::UmiControl *puc) { return ((puc->eType() & 0x5)==0x5); }
  extern GpibPeek* pGpibPeek(Umi::UmiControl *);
  inline const GpibPeek* pGpibPeek(const Umi::UmiControl *puc) { return pGpibPeek(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibPoke(const Umi::UmiControl *puc) { return ((puc->eType() & 0x6)==0x6); }
  extern GpibPoke* pGpibPoke(Umi::UmiControl *);
  inline const GpibPoke* pGpibPoke(const Umi::UmiControl *puc) { return pGpibPoke(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibSta(const Umi::UmiControl *puc) { return ((puc->eType() & 0x7)==0x7); }
  extern GpibSta* pGpibSta(Umi::UmiControl *);
  inline const GpibSta* pGpibSta(const Umi::UmiControl *puc) { return pGpibSta(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibTrf(const Umi::UmiControl *puc) { return ((puc->eType() & 0x8)==0x8); }
  extern GpibTrf* pGpibTrf(Umi::UmiControl *);
  inline const GpibTrf* pGpibTrf(const Umi::UmiControl *puc) { return pGpibTrf(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibInit(const Umi::UmiControl *puc) { return ((puc->eType() & 0x9)==0x9); }
  extern GpibInit* pGpibInit(Umi::UmiControl *);
  inline const GpibInit* pGpibInit(const Umi::UmiControl *puc) { return pGpibInit(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibFini(const Umi::UmiControl *puc) { return ((puc->eType() & 0xa)==0xa); }
  extern GpibFini* pGpibFini(Umi::UmiControl *);
  inline const GpibFini* pGpibFini(const Umi::UmiControl *puc) { return pGpibFini(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibCmd(const Umi::UmiControl *puc) { return ((puc->eType() & 0xb)==0xb); }
  extern GpibCmd* pGpibCmd(Umi::UmiControl *);
  inline const GpibCmd* pGpibCmd(const Umi::UmiControl *puc) { return pGpibCmd(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibCwr(const Umi::UmiControl *puc) { return ((puc->eType() & 0xc)==0xc); }
  extern GpibCwr* pGpibCwr(Umi::UmiControl *);
  inline const GpibCwr* pGpibCwr(const Umi::UmiControl *puc) { return pGpibCwr(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibCrd(const Umi::UmiControl *puc) { return ((puc->eType() & 0xd)==0xd); }
  extern GpibCrd* pGpibCrd(Umi::UmiControl *);
  inline const GpibCrd* pGpibCrd(const Umi::UmiControl *puc) { return pGpibCrd(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibResp(const Umi::UmiControl *puc) { return ((puc->eType() & 0xe)==0xe); }
  extern GpibResp* pGpibResp(Umi::UmiControl *);
  inline const GpibResp* pGpibResp(const Umi::UmiControl *puc) { return pGpibResp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibRdResp(const Umi::UmiControl *puc) { return ((puc->eType() & 0xf)==0xf); }
  extern GpibRdResp* pGpibRdResp(Umi::UmiControl *);
  inline const GpibRdResp* pGpibRdResp(const Umi::UmiControl *puc) { return pGpibRdResp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibWrResp(const Umi::UmiControl *puc) { return ((puc->eType() & 0x10)==0x10); }
  extern GpibWrResp* pGpibWrResp(Umi::UmiControl *);
  inline const GpibWrResp* pGpibWrResp(const Umi::UmiControl *puc) { return pGpibWrResp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibInfoResp(const Umi::UmiControl *puc) { return ((puc->eType() & 0x11)==0x11); }
  extern GpibInfoResp* pGpibInfoResp(Umi::UmiControl *);
  inline const GpibInfoResp* pGpibInfoResp(const Umi::UmiControl *puc) { return pGpibInfoResp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibIfc(const Umi::UmiControl *puc) { return ((puc->eType() & 0x12)==0x12); }
  extern GpibIfc* pGpibIfc(Umi::UmiControl *);
  inline const GpibIfc* pGpibIfc(const Umi::UmiControl *puc) { return pGpibIfc(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibRen(const Umi::UmiControl *puc) { return ((puc->eType() & 0x13)==0x13); }
  extern GpibRen* pGpibRen(Umi::UmiControl *);
  inline const GpibRen* pGpibRen(const Umi::UmiControl *puc) { return pGpibRen(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibWait(const Umi::UmiControl *puc) { return ((puc->eType() & 0x14)==0x14); }
  extern GpibWait* pGpibWait(Umi::UmiControl *);
  inline const GpibWait* pGpibWait(const Umi::UmiControl *puc) { return pGpibWait(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibLnReq(const Umi::UmiControl *puc) { return ((puc->eType() & 0x15)==0x15); }
  extern GpibLnReq* pGpibLnReq(Umi::UmiControl *);
  inline const GpibLnReq* pGpibLnReq(const Umi::UmiControl *puc) { return pGpibLnReq(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibLnResp(const Umi::UmiControl *puc) { return ((puc->eType() & 0x16)==0x16); }
  extern GpibLnResp* pGpibLnResp(Umi::UmiControl *);
  inline const GpibLnResp* pGpibLnResp(const Umi::UmiControl *puc) { return pGpibLnResp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibCsm(const Umi::UmiControl *puc) { return ((puc->eType() & 0x17)==0x17); }
  extern GpibCsm* pGpibCsm(Umi::UmiControl *);
  inline const GpibCsm* pGpibCsm(const Umi::UmiControl *puc) { return pGpibCsm(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibIst(const Umi::UmiControl *puc) { return ((puc->eType() & 0x18)==0x18); }
  extern GpibIst* pGpibIst(Umi::UmiControl *);
  inline const GpibIst* pGpibIst(const Umi::UmiControl *puc) { return pGpibIst(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibRtl(const Umi::UmiControl *puc) { return ((puc->eType() & 0x19)==0x19); }
  extern GpibRtl* pGpibRtl(Umi::UmiControl *);
  inline const GpibRtl* pGpibRtl(const Umi::UmiControl *puc) { return pGpibRtl(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibPpc(const Umi::UmiControl *puc) { return ((puc->eType() & 0x1a)==0x1a); }
  extern GpibPpc* pGpibPpc(Umi::UmiControl *);
  inline const GpibPpc* pGpibPpc(const Umi::UmiControl *puc) { return pGpibPpc(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibRpp(const Umi::UmiControl *puc) { return ((puc->eType() & 0x1b)==0x1b); }
  extern GpibRpp* pGpibRpp(Umi::UmiControl *);
  inline const GpibRpp* pGpibRpp(const Umi::UmiControl *puc) { return pGpibRpp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibRppResp(const Umi::UmiControl *puc) { return ((puc->eType() & 0x1c)==0x1c); }
  extern GpibRppResp* pGpibRppResp(Umi::UmiControl *);
  inline const GpibRppResp* pGpibRppResp(const Umi::UmiControl *puc) { return pGpibRppResp(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibDeviceStatus(const Umi::UmiControl *puc) { return ((puc->eType() & 0x1d)==0x1d); }
  extern GpibDeviceStatus* pGpibDeviceStatus(Umi::UmiControl *);
  inline const GpibDeviceStatus* pGpibDeviceStatus(const Umi::UmiControl *puc) { return pGpibDeviceStatus(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibDeviceOutput(const Umi::UmiControl *puc) { return ((puc->eType() & 0x1e)==0x1e); }
  extern GpibDeviceOutput* pGpibDeviceOutput(Umi::UmiControl *);
  inline const GpibDeviceOutput* pGpibDeviceOutput(const Umi::UmiControl *puc) { return pGpibDeviceOutput(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibDeviceInitAck(const Umi::UmiControl *puc) { return ((puc->eType() & 0x1f)==0x1f); }
  extern GpibDeviceInitAck* pGpibDeviceInitAck(Umi::UmiControl *);
  inline const GpibDeviceInitAck* pGpibDeviceInitAck(const Umi::UmiControl *puc) { return pGpibDeviceInitAck(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibDeviceInput(const Umi::UmiControl *puc) { return ((puc->eType() & 0x20)==0x20); }
  extern GpibDeviceInput* pGpibDeviceInput(Umi::UmiControl *);
  inline const GpibDeviceInput* pGpibDeviceInput(const Umi::UmiControl *puc) { return pGpibDeviceInput(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibDeviceEvent(const Umi::UmiControl *puc) { return ((puc->eType() & 0x21)==0x21); }
  extern GpibDeviceEvent* pGpibDeviceEvent(Umi::UmiControl *);
  inline const GpibDeviceEvent* pGpibDeviceEvent(const Umi::UmiControl *puc) { return pGpibDeviceEvent(const_cast<Umi::UmiControl*>(puc)); }
  inline bool isGpibDeviceStatusReport(const Umi::UmiControl *puc) { return ((puc->eType() & 0x22)==0x22); }
  extern GpibDeviceStatusReport* pGpibDeviceStatusReport(Umi::UmiControl *);
  inline const GpibDeviceStatusReport* pGpibDeviceStatusReport(const Umi::UmiControl *puc) { return pGpibDeviceStatusReport(const_cast<Umi::UmiControl*>(puc)); }

  #define MSG_GpibNop 0x4
  #define MSG_GpibPeek 0x5
  #define MSG_GpibPoke 0x6
  #define MSG_GpibSta 0x7
  #define MSG_GpibTrf 0x8
  #define MSG_GpibInit 0x9
  #define MSG_GpibFini 0xa
  #define MSG_GpibCmd 0xb
  #define MSG_GpibCwr 0xc
  #define MSG_GpibCrd 0xd
  #define MSG_GpibResp 0xe
  #define MSG_GpibRdResp 0xf
  #define MSG_GpibWrResp 0x10
  #define MSG_GpibInfoResp 0x11
  #define MSG_GpibIfc 0x12
  #define MSG_GpibRen 0x13
  #define MSG_GpibWait 0x14
  #define MSG_GpibLnReq 0x15
  #define MSG_GpibLnResp 0x16
  #define MSG_GpibCsm 0x17
  #define MSG_GpibIst 0x18
  #define MSG_GpibRtl 0x19
  #define MSG_GpibPpc 0x1a
  #define MSG_GpibRpp 0x1b
  #define MSG_GpibRppResp 0x1c
  #define MSG_GpibDeviceStatus 0x1d
  #define MSG_GpibDeviceOutput 0x1e
  #define MSG_GpibDeviceInitAck 0x1f
  #define MSG_GpibDeviceInput 0x20
  #define MSG_GpibDeviceEvent 0x21
  #define MSG_GpibDeviceStatusReport 0x22

  class Gpib_gco_Proto:public Umi::UmiProto {
   public:
    xistream& unmarsh(xistream &, const Umi::UmiControl &, Umi::UmiControl *) const;
    xostream& marshal(xostream &, const Umi::UmiControl *) const ;
    Gpib_gco_Proto();
    ~Gpib_gco_Proto();
  };

  class Gpib_gti_Proto:public Umi::UmiProto {
   public:
    xistream& unmarsh(xistream &, const Umi::UmiControl &, Umi::UmiControl *) const;
    xostream& marshal(xostream &, const Umi::UmiControl *) const ;
    Gpib_gti_Proto();
    ~Gpib_gti_Proto();
  };

  class Gpib_gdi_Proto:public Umi::UmiProto {
   public:
    xistream& unmarsh(xistream &, const Umi::UmiControl &, Umi::UmiControl *) const;
    xostream& marshal(xostream &, const Umi::UmiControl *) const ;
    Gpib_gdi_Proto();
    ~Gpib_gdi_Proto();
  };

  #define PROTID_gco "(/Int1:bool,Int1:u_int,Int1:bool,Int1:u_int/)(/Int1:char,Int1:bool,Int1:bool,Int1:bool,Int1:bool/)(/Int1:u_int,Int1:bool,Int1:bool,Int1:char/)(/Int4:u_int,Int1:bool/(/Int4:u_int,Int4:u_int/))((/Int4:u_int,Int1:bool/(/Int4:u_int,Int4:u_int/))//)((/Int4:u_int,Int1:bool/(/Int4:u_int,Int4:u_int/))//(/Int1:char,Int1:bool,Int1:bool,Int1:bool,Int1:bool/))(/Int4:u_int/(/Int1:u_int,Int1:bool,Int1:bool,Int1:char/),(/Int4:u_int,Int4:u_int/))(//(/Int1:bool,Int1:u_int,Int1:bool,Int1:u_int/))(//)(/Int4:u_int,Int4:u_int,Int4:u_int/)((/Int4:u_int,Int4:u_int,Int4:u_int/)/Int1:bool,Int1:bool/)((/Int4:u_int,Int4:u_int,Int4:u_int/)/Int4:u_int/)(/Int1:u_int,Int4:u_int,Int4:u_int/)((/Int4:u_int,Int4:u_int,Int4:u_int/)//(/Int1:u_int,Int4:u_int,Int4:u_int/))(//(/Int4:u_int,Int4:u_int/))(/Int4:u_int,Int4:u_int/(/Int4:u_int,Int4:u_int/))(/Int1:bool/)(/Int2:u_int,Int1:bool,Int1:bool/)(//)((/Int4:u_int,Int4:u_int,Int4:u_int/)/Int4:u_int/)(/Int1:bool,Int1:bool/)(/Int1:bool/)(//)(/Int1:bool,Int1:u_int/)(//)((/Int4:u_int,Int4:u_int,Int4:u_int/)/Int1:u_int/)"

  #define PROTID_gti "(/Int1:u_int/)((/Int1:u_int/)/Int1:u_int/)(//)(/Int4:u_int,Int4:u_int,Int4:u_int/)((/Int4:u_int,Int4:u_int,Int4:u_int/)//(/Int1:u_int,Int4:u_int,Int4:u_int/))"

  #define PROTID_gdi "(/Int4:u_int/)((/Int4:u_int/)/Int1:bool/)((/Int4:u_int/)/Int4:u_int/)(/Int1:bool/)(//)(/Int4:u_int,Int4:u_int,Int4:u_int/)"
}
#endif
